import 'package:fis_lib_report/report/interfaces/position_layout.dart';
import 'package:flutter/widgets.dart';

class AlignmentConvert {
  //文本布局转换
  static TextAlignVertical verticalAlignmentConvert(VerticalLayout? value) {
    if (value == null) {
      return TextAlignVertical.center;
    }
    switch (value) {
      case VerticalLayout.Top:
        return TextAlignVertical.top;
      case VerticalLayout.Bottom:
        return TextAlignVertical.bottom;
      case VerticalLayout.Center:
        return TextAlignVertical.center;
      case VerticalLayout.Stretch:
        return TextAlignVertical.center;
    }
  }

  ///水平布局转换
  static TextAlign horizontalAlignmentConvert(HorizontalLayout? value) {
    if (value == null) {
      return TextAlign.center;
    } else {
      switch (value) {
        case HorizontalLayout.Left:
          return TextAlign.left;
        case HorizontalLayout.Center:
          return TextAlign.center;
        case HorizontalLayout.Right:
          return TextAlign.right;
        case HorizontalLayout.Stretch:
          return TextAlign.justify;
      }
    }
  }

  ///水平布局转为layout布局
  static MainAxisAlignment horizontalToMainConvert(HorizontalLayout? value) {
    if (value == null) {
      return MainAxisAlignment.start;
    } else {
      switch (value) {
        case HorizontalLayout.Left:
          return MainAxisAlignment.start;
        case HorizontalLayout.Center:
          return MainAxisAlignment.center;
        case HorizontalLayout.Right:
          return MainAxisAlignment.end;
        case HorizontalLayout.Stretch:
          return MainAxisAlignment.start;
      }
    }
  }

  ///水平布局转Wrap布局
  static WrapAlignment wrapAlignment(HorizontalLayout? value) {
    if (value == null) {
      return WrapAlignment.start;
    } else {
      switch (value) {
        case HorizontalLayout.Left:
          return WrapAlignment.start;
        case HorizontalLayout.Center:
          return WrapAlignment.center;
        case HorizontalLayout.Right:
          return WrapAlignment.end;
        case HorizontalLayout.Stretch:
          return WrapAlignment.start;
      }
    }
  }

  ///竖直布局转换
  static Alignment verticalLayoutConvert(VerticalLayout? value) {
    if (value == null) {
      return Alignment.center;
    }
    switch (value) {
      case VerticalLayout.Top:
        return Alignment.topCenter;
      case VerticalLayout.Bottom:
        return Alignment.bottomCenter;
      case VerticalLayout.Center:
        return Alignment.center;
      case VerticalLayout.Stretch:
        return Alignment.centerLeft;
    }
  }

  ///水平布局转Aliment布局
  static Alignment horizontalConvert(HorizontalLayout? value) {
    if (value == null) {
      return Alignment.center;
    }
    switch (value) {
      case HorizontalLayout.Left:
        return Alignment.centerLeft;
      case HorizontalLayout.Right:
        return Alignment.centerRight;
      case HorizontalLayout.Center:
        return Alignment.center;
      case HorizontalLayout.Stretch:
        return Alignment.centerLeft;
    }
  }
}
