import 'package:fis_lib_report/pages/components/input_imageList.dart';
import 'package:fis_lib_report/pages/helper.dart';
import 'package:fis_lib_report/pages/paragraph_page.dart';
import 'package:fis_lib_report/pages/rt_table.dart';
import 'package:fis_lib_report/report/element_type.dart';
import 'package:fis_lib_report/report/input_image_list.dart';
import 'package:fis_lib_report/report/interfaces/block_element.dart';
import 'package:fis_lib_report/report/paragraph.dart';
import 'package:fis_lib_report/report/rt_table.dart';
import 'package:fis_ui/index.dart';
import 'package:flutter/material.dart';

class FBlockElementPage extends StatefulWidget implements FWidget {
  const FBlockElementPage({required this.element, Key? key}) : super(key: key);

  final IBlockElement element;

  @override
  State<StatefulWidget> createState() {
    return _BlockElementState();
  }
}

class _BlockElementState extends State<FBlockElementPage> {
  ElementType get _type => widget.element.elementType!;
  @override
  initState() {
    super.initState();
  }

  @override
  FWidget build(BuildContext context) {
    if (_type.name == ElementType.rtTable.name) {
      RTTable t = widget.element as RTTable;
      return FRTTablePage(element: t);
    } else if (_type.name == ElementType.paragraph.name) {
      final paragraph = widget.element as Paragraph;
      return FParagraphPage(paragraph: paragraph);
    } else if (_type.name == ElementType.imageList.name) {
      final inputImageList = widget.element as InputImageList;
      return FCenter(
        child: FInputImageList(inputImageList, null),
      );
    }
    return FContainer(
      height: 20,
      decoration: TestBoxDecoration.buildDecoration(),
    );
  }
}
