import 'package:fis_lib_report/converts/pt_to_px_converter.dart';
import 'package:fis_lib_report/report/line.dart';
import 'package:fis_lib_report/report/rt_border.dart';
import 'package:fis_lib_report/report/rt_thickness.dart';
import 'package:fis_ui/index.dart';
import 'package:flutter/material.dart';

import 'widgets/dashed_decoration.dart';

class FLine extends StatefulWidget implements FWidget {
  final Line line;

  const FLine(this.line, {Key? key}) : super(key: key);

  @override
  State<StatefulWidget> createState() {
    return _LineState();
  }
}

class _LineState extends State<FLine> {
  _LineState();

  @override
  initState() {
    super.initState();
  }

  @override
  Widget build(BuildContext context) {
    final borderStyle = widget.line.borderStyle;
    final stroke = widget.line.stroke!;
    final a = stroke.a!;
    final r = stroke.r!;
    final g = stroke.g!;
    final b = stroke.b!;
    final margin = widget.line.margin ?? RTThickness.uniform(0);
    return Container(
      height: 10,
      alignment: Alignment.center,
      margin: EdgeInsets.only(
          top: margin.top!,
          bottom: margin.bottom!,
          right: margin.left!,
          left: margin.left!),
      width: PtToPxConverter.ptToPx(widget.line.width),
      child: borderStyle == RTBorderStyle.Solid
          ? FDivider(
              height: widget.line.thickness,
              thickness: widget.line.thickness,
              color: Color.fromARGB(a, r, g, b),
            )
          : MySeparator(borderStyle: borderStyle ?? RTBorderStyle.Dash),
    );
  }
}
