import 'package:fis_lib_report/converts/pt_to_px_converter.dart';
import 'package:fis_lib_report/pages/components/widgets/option_row.dart';
import 'package:fis_lib_report/report/multi_selected_vertical.dart';
import 'package:fis_lib_report/report/rt_color.dart';
import 'package:fis_lib_report/report_info/multi_selected_vertical_info.dart';
import 'package:fis_lib_report/report_info/report_info.dart';
import 'package:fis_ui/define.dart';
import 'package:flutter/cupertino.dart';

class FMultiSelectedVertical extends StatefulWidget implements FWidget {
  final MultiSelectedVertical multiSelected;

  const FMultiSelectedVertical(this.multiSelected, {Key? key})
      : super(key: key);

  @override
  State<StatefulWidget> createState() {
    return _RRMultiSelectedVerticalState();
  }
}

class _RRMultiSelectedVerticalState extends State<FMultiSelectedVertical> {
  List<String> _selectedItems = [];
  List<String> _items = [];
  double _width = 0.0;
  TextStyle _textStyle = const TextStyle();
  MulitiSelectedVerticalInfo? _mulitiSelectedInfo;
  @override
  Widget build(BuildContext context) {
    _initDatas();
    return Column(
      children: [
        ...widget.multiSelected.items!.map((e) => FOptionRow(
              widget.multiSelected,
              e,
              isActive: true,
              height: 22,
              onTap: () {
                if (mounted) {
                  setState(() {
                    _onSelectedItem(e);
                  });
                }
              },
              isSelected: _selectedItems.contains(e),
            ))
      ],
    );
  }

  void _initDatas() {
    final multiSelected = widget.multiSelected;
    final selectInfo = FReportInfo.instance.getElementInfo(multiSelected);
    if (selectInfo != null && _mulitiSelectedInfo != selectInfo) {
      _mulitiSelectedInfo = selectInfo as MulitiSelectedVerticalInfo;
      _mulitiSelectedInfo!.onSelectedChange.dispose();
      _mulitiSelectedInfo!.onSelectedChange.addListener((sender, e) {
        if (mounted) {
          setState(() {
            _selectedItems = e;
          });
        }
      });
    }
    if (multiSelected.items!.isNotEmpty) {
      _items = multiSelected.items!;
    }
    if (_mulitiSelectedInfo!.selectedItems != _selectedItems) {
      _selectedItems = _mulitiSelectedInfo!.selectedItems;
    }
    _width = PtToPxConverter.ptToPx(multiSelected.lineWidth);
    final fontColor = multiSelected.fontColor ?? RTColor.Black;
    _textStyle = TextStyle(
      color: Color.fromARGB(
          fontColor.a!, fontColor.r!, fontColor.g!, fontColor.b!),
      fontSize: PtToPxConverter.ptToPx(multiSelected.fontSize),
    );
  }

  _onSelectedItem(String value) {
    if (_selectedItems.contains(value)) {
      _selectedItems.remove(value);
    } else {
      _selectedItems.add(value);
    }
    if (_mulitiSelectedInfo != null) {
      _mulitiSelectedInfo!.selectedItems = _selectedItems;
    }
  }
}
