import 'dart:convert' as convert;

import 'package:fis_lib_report/converts/alignment_convert.dart';
import 'package:fis_lib_report/converts/margin_convert.dart';
import 'package:fis_lib_report/converts/pt_to_px_converter.dart';
import 'package:fis_lib_report/report/static_image.dart';
import 'package:fis_ui/index.dart';
import 'package:flutter/cupertino.dart';
import 'package:flutter/material.dart';

class FStaticImage extends StatefulWidget implements FWidget {
  final StaticImage staticImage;

  const FStaticImage(this.staticImage, {Key? key}) : super(key: key);
  @override
  State<StatefulWidget> createState() {
    return _FStaticImageState();
  }
}

class _FStaticImageState extends State<FStaticImage> {
  _FStaticImageState();

  @override
  initState() {
    super.initState();
  }

  @override
  FWidget build(BuildContext context) {
    final _bytes = convert.base64Decode(widget.staticImage.source!);
    return FContainer(
      height: PtToPxConverter.ptToPx(widget.staticImage.imageHeight),
      width: PtToPxConverter.ptToPx(widget.staticImage.imageWidth),
      alignment: AlignmentConvert.horizontalConvert(
          widget.staticImage.horizontalAlignment),
      margin: MarginConvert.marginConvert(widget.staticImage.margin),
      child: FImage.memory(
        _bytes,
        fit: BoxFit.fill,
      ),
    );
  }
}
