import 'package:fis_lib_report/report/rt_border.dart';
import 'package:flutter/material.dart';

class MySeparator extends StatelessWidget {
  final double height;
  final RTBorderStyle borderStyle;
  final Color color;

  const MySeparator(
      {this.height = 1,
      this.borderStyle = RTBorderStyle.Dash,
      this.color = Colors.black,
      Key? key})
      : super(key: key);

  @override
  Widget build(BuildContext context) {
    double dashWidth = 4.0;
    switch (borderStyle) {
      case RTBorderStyle.None:
        break;
      case RTBorderStyle.Solid:
        break;
      case RTBorderStyle.Dash:
        dashWidth = 3;
        break;
      case RTBorderStyle.Dot:
        dashWidth = 1;
        break;
      case RTBorderStyle.DashDot:
        break;
      case RTBorderStyle.DashDotDot:
        break;
      case RTBorderStyle.Double:
        break;
    }
    return LayoutBuilder(
      builder: (BuildContext context, BoxConstraints constraints) {
        final boxWidth = constraints.constrainWidth();
        final dashHeight = height;
        final dashCount = (boxWidth / (2 * dashWidth)).floor();
        return Flex(
          children: List.generate(dashCount, (_) {
            return SizedBox(
              width: dashWidth,
              height: dashHeight,
              child: DecoratedBox(
                decoration: BoxDecoration(color: color),
              ),
            );
          }),
          mainAxisAlignment: MainAxisAlignment.spaceBetween,
          direction: Axis.horizontal,
        );
      },
    );
  }
}
