import 'dart:ui';
import 'package:flutter/material.dart';
import 'package:get/get.dart';
import 'package:fis_theme/theme.dart';

class AppTheme extends FTheme {
  @override
  void applyThemeData() {
    final lightData = getInnerThemeData(Brightness.light);
    final darkData = getInnerThemeData(Brightness.dark);

    // 手动设置数据&触发更新
    Get.changeTheme(
        currentBrightness == Brightness.dark ? darkData : lightData);
  }

  AppTheme(
      {String defaultName = "lightness",
      ThemeMode themeMode = ThemeMode.system})
      : super(defaultName: defaultName, themeMode: themeMode);

  @override
  Brightness get currentBrightness => (Brightness.light);

  @override
  bool get isCurrentChinese => true;
}
