enum ElementTagType {
  General,
  DiagnosticEntry,
  OtherMeasure,
  CommonMeasure,
}

class ElementTag {
  String? id;
  String? name;
  String? displayName;
  bool? isDefault;
  ElementTagType? elementTagType;

  ElementTag({
    required this.id,
    required this.name,
    required this.displayName,
    required this.elementTagType,
    required this.isDefault,
  });

  ElementTag.fromJson(Map<String, dynamic> json) {
    id = json['Id'];
    name = json['Name'];
    displayName = json['DisplayName'];
    if (json['IsDefault'] is String && json['IsDefault'].toString().isEmpty) {
      isDefault = false;
    } else {
      isDefault = json['IsDefault'];
    }
    elementTagType = ElementTagType.values
        .firstWhere((element) => element.name == json['ElementTagType']);
  }
}
