import 'package:fis_lib_report/report/interfaces/input_text.dart';
import 'package:fis_lib_report/report/text_element.dart';

class InputText extends TextElement implements IInputText {
  @override
  bool isReadOnly = false;

  ///语音输入or测量结果标志
  late List<String> featureTag;

  InputText.fromJson(Map<String, dynamic> json) : super.fromJson(json) {
    isReadOnly = json['IsReadOnly'];
    featureTag = [];
    if (json['FeatureTag'] != null && json['FeatureTag'] is List<dynamic>) {
      List<dynamic> feature = json['FeatureTag'] ?? [];
      if (feature.isNotEmpty) {
        for (var f in feature) {
          featureTag.add(f.toString());
        }
      }
    }
  }
}
