import 'package:fis_lib_report/report/element_tag.dart';
import 'package:fis_lib_report/report/element_type.dart';
import 'package:fis_lib_report/report/interfaces/position_layout.dart';
import 'package:fis_lib_report/report/interfaces/report_element.dart';
import 'package:fis_lib_report/report/measure_tag.dart';
import 'package:fis_lib_report/report/rt_thickness.dart';

abstract class IElement extends IReportElement {
  /// Gets or sets the element index.
  int? index;

  /// Gets the parent element.
  IReportElement? parent;

  /// Gets or sets the input tag to indicates what value should be show in this element.
  ElementTag? tag;

  ///Gets or sets the input tag to indicates what value should be show in this element.
  MeasureTag? measureTag;

  ///Gets or sets the horizontal alignment of the element.
  HorizontalLayout? horizontalAlignment;

  /// Gets or sets the vertical alignment of the element.
  VerticalLayout? verticalAlignment;

  ///Gets the block element margin.
  RTThickness? margin;

  ///Gets the element type.
  ElementType? elementType;
}
