import 'package:fis_lib_report/report/interfaces/block_element.dart';
import 'package:fis_lib_report/report/interfaces/cell.dart';

class RTColumnDefinition {
  double? width;
  RTColumnDefinition(this.width);

  RTColumnDefinition.fromJson(Map<String, dynamic> json) {
    width = json["Width"];
  }
}

class RTRowDefinition {
  double? minHeight = 18;
  double? height;
  WidthTypeEnum? type;

  RTRowDefinition(
    this.height,
    this.type,
    this.minHeight,
  );

  RTRowDefinition.fromJson(Map<String, dynamic> json) {
    var targetMinHeight = json['MinHeight'];
    minHeight = targetMinHeight < 26 ? 26 : targetMinHeight;
    double targetHeight = double.parse(json['Height'].toString());
    height = targetHeight < 28 ? 28 : targetHeight;
    if (json['Type'] != null) {
      type = WidthTypeEnum.values
          .firstWhere((element) => element.name == json['Type']);
    }
  }
}

abstract class IGrid extends IBlockElement {
  List<RTColumnDefinition>? columnDefinitions;
  List<RTRowDefinition>? rowDefinitions;
}
