import 'package:fis_lib_report/report/element_tag.dart';
import 'package:fis_lib_report/report/interfaces/block_element.dart';
import 'package:fis_lib_report/report/interfaces/report_element.dart';
import 'package:fis_lib_report/report/interfaces/report_template_body.dart';
import 'package:fis_lib_report/report/rt_page_size.dart';
import 'package:fis_lib_report/report/rt_thickness.dart';

abstract class IReportTemplateDocument extends IReportElement
    implements IReportTemplateBody {
  DateTime? updateTime;
  bool? isCustom;
  String? author;
  String? name;
  RTThickness? pagePadding;
  RTPageSize? pageSize;
  double? headerHeight;
  double? footerHeight;
  double? headerDistance;
  double? footerDistance;
  Map<String, ElementTag>? tags;
  Map<String, Map<String, String>>? customizeTranslation;

  Set<String>? customizeComments;

  Set<String>? customizeReportComments;

  Set<String>? customizeCalculations;

  List<IBlockElement>? blocks;
  List<IBlockElement>? footer;
  List<IBlockElement>? header;

  bool? invertColor;
  double? baseFontSize;
  String? version;
}
