import 'package:fis_lib_report/converts/int_to_double_convert.dart';
import 'package:fis_lib_report/report/interfaces/line.dart';
import 'package:fis_lib_report/report/rt_border.dart';
import 'package:fis_lib_report/report/rt_color.dart';
import 'package:fis_lib_report/report/shape.dart';

class Line extends Shape implements ILine {
  @override
  RTColor? stroke;

  @override
  double? thickness;

  @override
  RTBorderStyle? borderStyle;

  @override
  double? width;

  Line.fromJson(Map<String, dynamic> json) : super.fromJson(json) {
    stroke = RTColor.fromJson(json['Stroke']);
    width = json['Width'];
    thickness = IntToDouble.intToDouble(json['Thickness']);
    if (RTBorderStyle.values
        .any((element) => element.name == json['BorderStyle'])) {
      borderStyle = RTBorderStyle.values
          .firstWhere((element) => element.name == json['BorderStyle']);
    }
  }
}
