import 'package:fis_lib_report/report/element_type.dart';
import 'package:fis_lib_report/report/interfaces/report_element.dart';
import 'package:fis_lib_report/report/interfaces/rt_table.dart';
import 'package:fis_lib_report/report/rt_grid.dart';

class RTTable extends RTGrid implements IRTTable {
  @override
  bool? autoHide;
  @override
  bool? isFoldOccupy;
  bool? isAverageColumnWidth;
  bool? allowBreakAcrossPages;

  RTTable(IReportElement parent) : super(parent) {
    elementType = ElementType.rtTable;
    allowBreakAcrossPages = true;
  }

  RTTable.fromJson(Map<String, dynamic> json) : super.fromJson(json) {
    autoHide = json['AutoHide'];
    isAverageColumnWidth = json['IsAverageColumnWidth'];
    allowBreakAcrossPages = json['AllowBreakAcrossPages'];
    if (json.containsKey("IsFoldOccupy")) {
      isFoldOccupy = json["IsFoldOccupy"];
    }
  }
}
