import 'package:fis_lib_report/converts/int_to_double_convert.dart';
import 'package:fis_lib_report/report/element.dart';
import 'package:fis_lib_report/report/interfaces/block_element.dart';
import 'package:fis_lib_report/report/interfaces/element.dart';
import 'package:fis_lib_report/report/interfaces/input_image_list.dart';

class StaticImage extends Element
    implements IBlockElement, IInputImageListElement {
  @override
  int? column;

  @override
  List<IElement>? elements;

  @override
  bool? hasGap;

  @override
  bool? hasImageBorder;

  @override
  bool? transparentBackground;

  late double imageWidth;

  late double imageHeight;

  bool? isReadOnly;

  String? source;

  StaticImage.fromJson(Map<String, dynamic> json) : super.fromJson(json) {
    column = json['Column'];
    hasGap = json['HasGap'];
    hasImageBorder = json['HasImageBorder'];
    transparentBackground = json['TransparentBackground'];
    imageWidth = IntToDouble.intToDouble(json['Width']);
    imageHeight = IntToDouble.intToDouble(json['Height']);
    isReadOnly = json['IsReadOnly'];
    source = json['Source'];
  }
}
