import 'package:fis_lib_report/report/element_tag.dart';
import 'package:fis_lib_report/report/element_type.dart';
import 'package:fis_lib_report/report/interfaces/element.dart';
import 'package:fis_lib_report/report/interfaces/report_element.dart';
import 'package:fis_lib_report/report/measure_tag.dart';

abstract class ElementInfo {
  ElementInfo();

  @override
  ElementType? elementType;

  @override
  int? index;

  @override
  MeasureTag? measureTag;

  @override
  IReportElement? parent;

  @override
  ElementTag? tag;

  @override
  String? id;

  IElement? element;

  ElementInfo.fromElement(IElement element) {
    this.element = element;
    elementType = element.elementType;
    index = element.index;
    measureTag = element.measureTag;
    parent = element.parent;
    tag = element.tag;
    id = element.id;
  }

  Map<String, dynamic> toJson() => {
        'Index': index,
        'Id': id,
        'ElementType': elementType!.toJson(),
        'MeasureTag': measureTag == null ? null : measureTag!.toJson(),
      };
}
