import 'package:fis_lib_report/converts/event_type.dart';
import 'package:fis_lib_report/report/input_image.dart';
import 'package:fis_lib_report/report_info/block_element_info_interface.dart';
import 'package:fis_lib_report/report_info/element_info.dart';
import 'package:fis_lib_report/report_info/report_info.dart';

class InputImageInfo extends ElementInfo implements IBlockElementInfo {
  ///列数
  int? column;

  ///是否有缝隙
  bool? hasGap;

  ///是否只读
  bool? isReadOnly;

  ///当前是否处于选中状态
  bool? isSelected;

  ///已选图像
  String get selectedImage => _selectedImage;
  set selectedImage(String v) {
    _selectedImage = v;
    onSelectedChange.emit(this, v);
  }

  ///选中项改变通知UI变化
  FEventHandler<String> onSelectedChange = FEventHandler<String>();

  //图像选中时通知模板
  FEventHandler<String>? onSelect = FEventHandler();

  String _selectedImage = '';

  InputImageInfo.fromElement(InputImage inputImage)
      : super.fromElement(inputImage) {
    column = inputImage.column;
    hasGap = inputImage.hasGap;
    isReadOnly = inputImage.isReadOnly;
  }

  @override
  List<ElementInfo>? elementInfos;

  void addImage(String imageUrl) {
    _selectedImage = imageUrl;
    onSelect!.emit(this, imageUrl);
    FReportInfo.instance.setMockDatas
        .removeListener((sender, e) => showMockData());
    FReportInfo.instance.setMockDatas
        .addListener((sender, e) => showMockData());
  }

  @override
  Map<String, dynamic> toJson() {
    final map = <String, dynamic>{};
    map['Key'] = id;
    map['Value'] = selectedImage;
    map['Name'] = tag == null ? '' : tag!.name;
    map['TagId'] = tag == null ? '' : tag!.id;
    FReportInfo.instance.jsonItems.add(map);
    return map;
  }

  ///显示MOck数据
  showMockData() {
    selectedImage =
        'http://cdn-bj.fis.plus/db38b8d36a7b48ada3effe0a53ea8993.jpg';
  }
}
