import 'package:fis_lib_report/converts/event_type.dart';
import 'package:fis_lib_report/report/multi_selected.dart';
import 'package:fis_lib_report/report_info/report_info.dart';
import 'package:fis_lib_report/report_info/text_element_info.dart';

class MulitiSelectedInfo extends TextElementInfo {
  ///是否只读
  bool? isReadOnly = false;

  ///所有待选项
  List<String>? items = [];

  ///选中项集合
  List<String> get selectedItems => _selectedItems;
  set selectedItems(List<String> v) {
    _selectedItems = v;
    onSelectedChange.emit(this, v);
  }

  ///选中项改变通知UI变化
  FEventHandler<List<String>> onSelectedChange = FEventHandler<List<String>>();

  List<String> _selectedItems = [];

  MulitiSelectedInfo.fromElement(MultiSelected element)
      : super.fromElement(element) {
    items = element.items;
    isReadOnly = element.isReadOnly;
    FReportInfo.instance.setMockDatas
        .removeListener((sender, e) => _showMockData());
    FReportInfo.instance.setMockDatas
        .addListener((sender, e) => _showMockData());
  }

  @override
  Map<String, dynamic> toJson() {
    final map = <String, dynamic>{};
    map['Key'] = id;
    map['Value'] = selectedItems;
    map['Name'] = tag == null ? '' : tag!.name;
    map['TagId'] = tag == null ? '' : tag!.id;
    FReportInfo.instance.jsonItems.add(map);
    return map;
  }

  ///显示MOck数据
  _showMockData() {
    try {
      if (items!.isNotEmpty) {
        selectedItems = [items!.first];
      } else {
        items!.add('XX');
        selectedItems = ['XX'];
      }
    } catch (e) {
      print(e);
    }
  }
}
