import 'package:fis_lib_report/report/cell_postion.dart';
import 'package:fis_lib_report/report/interfaces/grid.dart';
import 'package:fis_lib_report/report/rt_table.dart';
import 'package:fis_lib_report/report_info/element_info.dart';
import 'package:fis_lib_report/report_info/rt_cell_info.dart';

class RTGridInfo extends ElementInfo {
  RTGridInfo() : super();

  @override
  List<RTColumnDefinition>? columnDefinitions = [];

  @override
  List<RTRowDefinition>? rowDefinitions = [];

  bool? isDelete;

  bool? isInsertColumn;

  int? deleteRowIndex;

  int? deleteColumnIndex;

  bool? isMergeCell;

  int? mergeDeleteStartColumnIndex;

  int? mergeDeleteEndColumnIndex;

  Map<CellPostion, RTCellInfo>? cells = {};

  RTGridInfo.fromElement(RTTable table) : super.fromElement(table) {
    columnDefinitions = table.columnDefinitions;
    rowDefinitions = table.rowDefinitions;
    isDelete = table.isDelete;
    isInsertColumn = table.isInsertColumn;
    deleteRowIndex = table.deleteColumnIndex;
    deleteColumnIndex = table.deleteColumnIndex;
    isMergeCell = table.isMergeCell;
    mergeDeleteStartColumnIndex = table.mergeDeleteStartColumnIndex;
    mergeDeleteEndColumnIndex = table.mergeDeleteEndColumnIndex;
    table.cells!.forEach((key, value) {
      cells![key] = RTCellInfo.fromElement(value);
    });
  }

  @override
  Map<String, dynamic> toJson() {
    final map = <String, dynamic>{};
    map.addAll(super.toJson());
    final blockInfos = [];
    cells!.forEach((key, value) {
      blockInfos.add(key.toJson());
      blockInfos.add(value.toJson());
    });
    map['Cells'] = blockInfos;
    return map;
  }
}
